(******************************************************************************)
(** * SRAG simulates SRAL: rmw step   *)
(******************************************************************************)

Require Import PeanoNat Lt Gt.
Require Import Lia.
Require Import Hahn.

Require Import AuxRel.
Require Import Basic.
Require Import Labels Events Execution.
Require Import SRALn Wmax SRAG.
Require Import Write_lists Match_SRAn.

Require Import FG.

Require Import GsimL_read_SRAn GsimL_write_SRAn.
Require Import LsimG_read_SRAn.

Set Implicit Arguments.

Lemma GsimL_rmw_helper st st'' 
 G t x vr vw 
 (SRAL: SRAL_step st st'' (Some (t, (Armw x vr vw))))
 (MATCH: SGmatch st G) ol (IN: In ol (st t))
 w (MAX: w_max G x w)
 wl (WF_WL: wf_wl wl ol G): 
 wl 0 x = w.
Proof. 
forward apply max_w_exists with (x:=x); try apply MATCH; ins; desc.
red in MATCH; desc.
specialize (NON_EMPTY_POT t).
destruct ol; desf.
eby exfalso; eapply NON_EMPTY_OL.
rename p into ps.
inversion SRAL; desf.
red in READ; desc.
specialize (READ _ IN ps).
assert (RMW: rmw_flag_opt (nth 0 (ps :: ol) init_ps x) = true).
by ins; rewrite READ; auto.
specialize (SMATCH _ _ IN); desc.
red in SMATCH; desc.
eapply wf_wl_last_max in RMW; try edone; ins; try lia.
eapply max_w_unique; try edone.
Qed.

Lemma GsimL_rmw_pick_w st st'' (* (WF_S: wf_state st'') *)
 G t x vr vw 
 (SRAL: SRAL_step st st'' (Some (t, (Armw x vr vw))))
 (MATCH: SGmatch st G) : 
 exists e, w_max G x e /\ valw e = vr.
Proof.
cdes MATCH.
specialize (NON_EMPTY_POT t).
assert (IN: exists ol, In ol (st t)).
by destruct (st t); desf; vauto.
desc.

forward apply max_w_exists with (x:=x); try apply MATCH; ins; desc.

specialize (SMATCH _ _ IN); desc.
red in SMATCH; desc.
forward eapply GsimL_rmw_helper; try edone.
ins; desf.

eexists; splits; eauto.



destruct ol; desf.
eby exfalso; eapply NON_EMPTY_OL.
rename p into ps.
inversion SRAL; desf.
red in READ; desc.
specialize (READ _ IN ps).
assert (RMW: rmw_flag_opt (nth 0 (ps :: ol) init_ps x) = true).
by ins; rewrite READ; auto.

red in WL_WF; desc.
rewrite WL_VAL; ins; try lia.
rewrite READ; ins.



Qed.

Lemma GsimL_rmw (st st'' : State) (G : execution)
      t x vr vw (SRAL: SRAL_step st st'' (Some (t, (Armw x vr vw))))
      (MATCH: SGmatch st G) : 
         exists G', SRAG_step G G' (Some (t, (Armw x vr vw))) /\ 
                    SGmatch st'' G'.
Proof.
forward (eapply GsimL_rmw_pick_w); try edone.
intros MAX; desf.
(* eapply SRAL_step_preserves_wf; [eapply MATCH|]; eauto.
intro MAX; desc.
cdes MAX; unfolder in MAX1; desc.
 *)
inversion SRAL; subst; clear SRAL.

remember (valw e) as vr.

forward (eapply exists_add' with (w:=e) (l:= Armw x vr vw) (t:=t)); try edone.
by apply MATCH.
by apply MAX.
by apply MAX.
by ins; apply MAX.
intro RMW_ADD; destruct RMW_ADD as [n [G' RMW_ADD]].
exists G'; splits.
by red; eexists _,_,_,_; splits; eauto 21; apply MATCH.

assert (MATCH':= MATCH).
apply SGmatch_SGmatch_fun in MATCH'; desc.

eapply GsimL_write_helper; try edone.
eapply SRAL_write_step_helper_preserves_wf; try edone.
eby eapply SGmatch_implies_wf_st.
eby eapply SGmatch_implies_wf_st.
apply MATCH.
ins.
eapply GsimL_rmw_helper; try edone.
econs; eauto.
apply MATCH'.
auto.
Qed.


