(******************************************************************************)
(** * SRAL simulates SRAG: rmw step   *)
(******************************************************************************)

Require Import PeanoNat Lt Gt.
Require Import Lia.
Require Import Hahn.

Require Import AuxRel.

Require Import Basic.

Require Import Labels Events Execution.
Require Import SRALn Wmax Add_max SRAG.
Require Import Write_lists Match_SRAn.

Require Import FG.

Require Import LsimG_read_SRAn LsimG_write_SRAn.

Set Implicit Arguments.

Lemma LsimG_rmw (st' : State) 
          (G G' : execution) 
          t x vr vw (SRAG: SRAG_step G G' (Some (t, (Armw x vr vw))))
           (MATCH': SGmatch st' G') :
          exists st, SRAL_step st st' (Some (t, (Armw x vr vw))) /\ 
                     SGmatch st G.
Proof.

forward eapply LsimG_write_main; try edone.
ins; desc.
specialize (H1 hahn__true_is_true).
exists st; splits; eauto.
econs; [|done].
red; ins.

red in SRAG; desf; ins.
specialize (MAX hahn__true_is_true).
clear CO.
rename t0 into t.

exists (tid w).
ins.


assert (LEN: 0 < length ol).
{ destruct ol; ins. lia. }

specialize (H1 _ IN).
replace (hd init_ps ol) with (nth 0 ol init_ps) in * by by destruct ol; desf.

cut (nth 0 ol init_ps x = RT (tid w) vr true).
by destruct ol; ins; desf; ins.
clear PS ps.

red in H0; desc.
specialize (SMATCH _ _ IN); desc.
red in SMATCH; desc.

assert (WW: w = wl 0 x).
{ eapply max_w_unique; try edone.
eapply wf_wl_last_max; try edone. }

replace vr with (valw w).
2: by apply ADD; vauto.
subst w.
red in WL_WF; desc.
rewrite WL_TID; try done.
rewrite WL_VAL; try done; vauto.

destruct (nth 0 ol init_ps x) eqn:E.
f_equal; ins.
Qed.

